#include "ymgroup.h"
#include "ymshell.h"

void static yalist_insert(yahoo_account *ya) {
	YGroupList *itr = buddygroups->next;
	yahoo_account_list *cur;
	do {
		if(!strcmp(ya->group, itr->name))
			break;
		itr = itr->next;
	}while(itr!=buddygroups->next);
	cur = (yahoo_account_list *)malloc(sizeof(yahoo_account_list));
	bzero(cur, sizeof(yahoo_account_list));
	cur->ya = ya;
	if(itr->ya_list) {
		cur->next = itr->ya_list->next;
		cur->prev = itr->ya_list;
		cur->next->prev = cur;
		cur->id = cur->next->id + 1;
		itr->ya_list->next = cur;
	}
	else {
		cur->next = cur;
		cur->prev = cur;
		cur->id = 1;
		itr->ya_list = cur;
	}
	return;
}

void static glist_insert(char *group) {
	YGroupList *itr;
	itr = (YGroupList *)malloc(sizeof(YGroupList));
	bzero(itr, sizeof(YGroupList ));
	if(buddygroups) {
		itr->prev = buddygroups;
		itr->next = buddygroups->next;
		itr->next->prev = itr;
		buddygroups->next = itr;
	}
	else {
		itr->prev = itr;
		itr->next = itr;
		buddygroups = itr;
	}
	strncpy(itr->name, group, GROUPNAME_S);
	return;
}

void mk_glist() {
	YGroupList *gitr;
	YList *itr;
	YList *last;
	yahoo_account *ya;
	yahoo_account *last_ya;
	unsigned short id = 1; 
	itr = buddies;
	ya = itr->data;
	glist_insert(ya->group);
	yalist_insert(ya);
	for (last = itr, itr=itr->next; itr; last = itr, itr = itr->next) {
		ya = itr->data;
		last_ya = last->data;
		if(strcmp(ya->group, last_ya->group))
			glist_insert(ya->group);
		yalist_insert(ya);
	}
	buddygroups->id = id++;
	buddygroups->empty = 1;
	for(gitr = buddygroups->prev; gitr != buddygroups; gitr = gitr->prev) {
		gitr->id = id++;
		gitr->empty = 1;
	}
	
	return;
}

void free_glist() {
	YGroupList *gitr, *g;
	yahoo_account_list *cur, *y;
	gitr = buddygroups;
	do{
		g = gitr->next;
		cur = gitr->ya_list;
		do{
			y = cur->next;
			free(cur);
			cur = y;
		}while(cur != gitr->ya_list);
		free(gitr);
		gitr = g;
	} while(gitr != buddygroups);
	buddygroups=NULL;
	return;
}

yahoo_account *search_glist(char *id) {
	YGroupList *gitr;
	yahoo_account_list *cur;
	gitr = buddygroups;
	do{
		cur = gitr->ya_list;
		do{
			if(!strcmp(cur->ya->yahoo_id, id))
				return cur->ya;
			cur = cur->next;
		}while(cur != gitr->ya_list);
		gitr = gitr->next;
	} while(gitr != buddygroups);
	return 0;
}
