#ifndef YMGROUP_H__
#define YMGROUP_H__

#define GROUPNAME_S 256
#include "ymshell.h"

struct yahoo_account;

typedef struct yahoo_account_list {
	unsigned int id;
	struct yahoo_account *ya;
	struct yahoo_account_list *next;
	struct yahoo_account_list *prev;
} yahoo_account_list;

typedef struct YGroupList {
	unsigned int id;
	char name[GROUPNAME_S];
	yahoo_account_list *ya_list;
	struct YGroupList *next;
	struct YGroupList *prev;
	_Bool empty;
} YGroupList;

void free_glist();
void mk_glist();
struct yahoo_account *search_glist(char *);
#endif
