#include "ymhistory.h"
#include <ncurses.h>
#include <string.h>
#include <stdlib.h>

struct histbuf hbufs[MAXHIST];
int curindex;
int curiter;

/* curindex starts at 0 runs till 99 and wraps around */

void ymshell_addcmdtohist(char *cmd)
{
	if(curindex == MAXHIST)
		curindex = 0;
	if(hbufs[curindex].cmd)
		free(hbufs[curindex].cmd);	
	
	hbufs[curindex].cmd = malloc(strlen(cmd) + 1);
	strncpy(hbufs[curindex].cmd, cmd, strlen(cmd)+1);
	curiter = curindex;
	++curindex;
}

/* 0 = up, 1 = down */
void ymshell_gethist(int updown)
{
	int y,x;
	getyx(stdscr, y, x);
	move(y, x-ix);
	clrtoeol();

	if(updown == 0)
	{
		for(ix = 0; ix < strlen(hbufs[curiter].cmd); ++ix)
		{
			mbuf[ix] = hbufs[curiter].cmd[ix];
			printw("%c", mbuf[ix]);
		}	
		if(updown == 0)	 --curiter;
		if(curiter < 0) curiter=curindex - 1;
	}
}	

